#pragma once
#include "NodeBase.h"

class HakoiriMusume :public NodeBase 
{
	enum eDirection { UP, DOWN, LEFT, RIGHT };
	static const int SIZE_X = 4;
	static const int SIZE_Y = 5;
	static const int GOAL_X = 1;
	static const int GOAL_Y = 3;
	static const int OBJECT_TYPE_NUM = 4;
	static const int SPACE_NUM = 2;
	static const int OBJECT_SIZE_W[OBJECT_TYPE_NUM];
	static const int OBJECT_SIZE_H[OBJECT_TYPE_NUM];
	static bool IS_SPACE(int c) { return c < 0; }
	static bool IS_OBJECT(int c) { return c >= 0; }
	static int SPACE_ID(int c) { return (-c) % 100; }

	int c[SIZE_X][SIZE_Y];
	int space_x[SPACE_NUM];
	int space_y[SPACE_NUM];
	int musume_x, musume_y;

	static int OBJECT_NUM;
	
	void expand(std::list<NodeBasePtr>*, const NodeBasePtr) const;
	bool finished() const;
	void print() const;
	bool equalTo(const NodeBasePtr) const;
	int h() const;
	int hash() const;
	bool judgeMovable(int x,int y,eDirection direction) const;
	static void move(HakoiriMusume *node,int ox,int oy, eDirection direction);
	static int min(int,int);
	static int distance(int, int, int, int);
public:
	HakoiriMusume(int Qnum);
	HakoiriMusume(const HakoiriMusume *, const NodeBasePtr parent);
};