#pragma once
#include <list>
#include <memory>
#include <iostream>
#include <stack>

class NodeBase;

typedef std::shared_ptr<NodeBase> NodeBasePtr;

class NodeBase
{
public:
	static int hmode;
	int depth;
	NodeBasePtr parent;
	virtual void expand(std::list<NodeBasePtr>*,const NodeBasePtr parent) const=0;
	virtual bool finished() const=0;
	virtual void print() const=0;
	int f() 
	{
		if (f_record != -1)return f_record;
		f_record = depth + h(); 
		if (f_record < 0)f_record--;
		return f_record;
	};
	int f_const() const 
	{
		if (f_record != -1)return f_record;
		return depth + h();
	}
	virtual int hash() const = 0;
	static void goal_print(NodeBasePtr goal)
	{
		std::stack<NodeBasePtr> nodes;
		NodeBasePtr node = goal;
		nodes.push(node);
		while(node->parent!=nullptr)
		{
			node = node->parent;
			nodes.push(node);
		}
		while (!nodes.empty())
		{
			node = nodes.top();
			std::cout << "depth=" << node->depth;
			std::cout << " f=" << node->f() << std::endl;
			node->print();
			nodes.pop();
		}
	}
	void rec_print() const 
	{
		if (parent != nullptr)parent->rec_print();
		std::cout << "depth=" << depth;
		std::cout << " f=" << f_const() << std::endl;
		print(); 
	}
	virtual bool equalTo(const NodeBasePtr) const=0;
protected:
	NodeBase() 
	{
		depth = 0;
		parent = nullptr;
		f_record = -1;
	}
	NodeBase(const NodeBasePtr parent_) 
	{
		depth = parent_->depth+1;
		parent = parent_;
		f_record = -1;
	}
	virtual int h() const= 0;
	void reset_f() { f_record = -1; }
private:
	int f_record;
};

