#include <iostream>
#include "SlidePuzzle.h"
#include "NoClueSudoku2.h"
#include <list>
#include "NodeBase.h"
#include "PuzzleSearch.h"
#include "HakoiriMusume.h"
#include <algorithm>
using namespace std;

int NodeBase::hmode;

int main(int argc, char* argv[])
{
	int Qnum, Snum;
	bool cmdFlag = false;
	if (argc > 2) 
	{
		sscanf(argv[1], "%d", &Qnum);
		sscanf(argv[2], "%d", &Snum);
		cmdFlag = true;
	}
	else 
	{
		cout << "Ił" << endl;
		cout << "1:肪Ȃ1(N=4,GROUP_NUM=2)" << endl;
		cout << "2:肪Ȃ2(N=5,GROUP_NUM=5)" << endl;
		cout << "3:肪Ȃ3(N=6,GROUP_NUM=9)" << endl;
		cout << "4:肪Ȃ4(N=6,GROUP_NUM=9)" << endl;
		cout << "5:肪Ȃ5(N=5,GROUP_NUM=3)" << endl;
		cout << "11:XChpY1(X=3,Y=3)" << endl;
		cout << "12:XChpY2(X=3,Y=3)" << endl;
		cout << "13:XChpY3(X=4,Y=3)" << endl;
		cout << "14:XChpY4(X=4,Y=4)" << endl;
		cout << "21:薺1" << endl;
		cout << "22:薺2" << endl;
		cout << "23:薺3" << endl;
		cout << "ԍF"; cin >> Qnum;

		cout << "T@Ił" << endl;
		cout << "0:[DT" << endl;
		cout << "1:[DT2([t)" << endl;
		cout << "2:DT" << endl;
		cout << "3:A*T[`1(q[XeBbNX1)" << endl;
		cout << "4:A*T[`2(q[XeBbNX2)" << endl;
		cout << "T@F"; cin >> Snum;
	}

	SearchResult result;

	switch (Qnum / 10)
	{
	case 0://肪Ȃ
		if (NoClueSudoku2::init(Qnum % 10) == false)return 0;
		result = Search(NodeBasePtr(new NoClueSudoku2()), (eSearchMode)Snum);
		break;
	case 1://XChpY
		result = Search(NodeBasePtr(new SlidePuzzle(Qnum % 10)), (eSearchMode)Snum);
		break;
	case 2://薺
		result = Search(NodeBasePtr(new HakoiriMusume(Qnum % 10)), (eSearchMode)Snum);
		break;
	default:
		cout << "ԍ܂" << endl;
		return 0;
	}
	cout << "count=" << result.count << endl;
	if (result.goal->depth > 100) 
	{
		cout << "ɐ[łBo͂܂H(1/0)";
		int flag;
		cin >> flag;
		if (flag == 0)return 0;
	}
	if (result.goal != nullptr)NodeBase::goal_print(result.goal);
	else cout << "܂łB" << endl;
	cout << "count=" << result.count << endl;
	if (Qnum / 10 == 0)NoClueSudoku2::clean();
	if (cmdFlag == false) 
	{
		cin.get();
		cin.get();
	}
	return 0;
}

